# Copyright 2022-2024 ETSI OSG/SDG TeraFlowSDN (TFS) (https://tfs.etsi.org/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

apiVersion: apps/v1
kind: Deployment
metadata:
  name: automationservice
spec:
  selector:
    matchLabels:
      app: automationservice
  replicas: 1
  template:
    metadata:
      annotations:
        # Required for IETF L2VPN SBI when both parent and child run in same K8s cluster with Linkerd
        config.linkerd.io/skip-outbound-ports: "2002"
      labels:
        app: automationservice
    spec:
      terminationGracePeriodSeconds: 5
      containers:
        - name: server
          image: labs.etsi.org:5050/tfs/controller/automation:latest
          imagePullPolicy: Always
          ports:
            - containerPort: 30200
            - containerPort: 9192
          env:
            - name: LOG_LEVEL
              value: "INFO"
          envFrom:
            - secretRef:
                name: crdb-analytics
            - secretRef:
                name: kfk-kpi-data
          startupProbe:
            exec:
              command: ["/bin/grpc_health_probe", "-addr=:30200"]
            failureThreshold: 30
            periodSeconds: 1
          readinessProbe:
            exec:
              command: ["/bin/grpc_health_probe", "-addr=:30200"]
          livenessProbe:
            exec:
              command: ["/bin/grpc_health_probe", "-addr=:30200"]
          resources:
            requests:
              cpu: 250m
              memory: 128Mi
            limits:
              cpu: 1000m
              memory: 1024Mi
---
apiVersion: v1
kind: Service
metadata:
  name: automationservice
  labels:
    app: automationservice
spec:
  type: ClusterIP
  selector:
    app: automationservice
  ports:
    - name: grpc
      protocol: TCP
      port: 30200
      targetPort: 30200
    - name: metrics
      protocol: TCP
      port: 9192
      targetPort: 9192
